summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2013-05-29 10:31:45 +0000
committerFelix Fietkau <nbd@openwrt.org>2013-05-29 10:31:45 +0000
commit6f4cb088a0ca2c0321b41d424f112586c5e363c8 (patch)
treee5a7be68122abdc78f2c07f09b00eaec14f488d9
parent5fbc56cfdc82ed6f7226217ad82fc3872c5ac3b3 (diff)
downloadmtk-20170518-6f4cb088a0ca2c0321b41d424f112586c5e363c8.zip
mtk-20170518-6f4cb088a0ca2c0321b41d424f112586c5e363c8.tar.gz
mtk-20170518-6f4cb088a0ca2c0321b41d424f112586c5e363c8.tar.bz2
build: clean up stale files from a previous build when installing a package build to the staging dir
Signed-off-by: Felix Fietkau <nbd@openwrt.org> SVN-Revision: 36755
-rw-r--r--include/package.mk5
-rwxr-xr-xscripts/clean-package.sh24
2 files changed, 29 insertions, 0 deletions
diff --git a/include/package.mk b/include/package.mk
index 99d2dd2..a4f353b 100644
--- a/include/package.mk
+++ b/include/package.mk
@@ -171,6 +171,11 @@ define Build/DefaultTargets
$(foreach hook,$(Hooks/InstallDev/Post),\
$(call $(hook),$(TMP_DIR)/stage-$(PKG_NAME),$(TMP_DIR)/stage-$(PKG_NAME)/host)$(sep)\
)
+ if [ -f $(STAGING_DIR)/packages/$(STAGING_FILES_LIST) ]; then \
+ $(SCRIPT_DIR)/clean-package.sh \
+ "$(STAGING_DIR)/packages/$(STAGING_FILES_LIST)" \
+ "$(STAGING_DIR)"; \
+ fi
if [ -d $(TMP_DIR)/stage-$(PKG_NAME) ]; then \
(cd $(TMP_DIR)/stage-$(PKG_NAME); find ./ > $(TMP_DIR)/stage-$(PKG_NAME).files); \
$(call locked, \
diff --git a/scripts/clean-package.sh b/scripts/clean-package.sh
new file mode 100755
index 0000000..d1a2578
--- /dev/null
+++ b/scripts/clean-package.sh
@@ -0,0 +1,24 @@
+#!/usr/bin/env bash
+[ -n "$1" -a -n "$2" ] || {
+ echo "Usage: $0 <file> <directory>"
+ exit 1
+}
+[ -f "$1" -a -d "$2" ] || {
+ echo "File/directory not found"
+ exit 1
+}
+cat "$1" | (
+ cd "$2"
+ while read entry; do
+ [ -n "$entry" ] || break
+ [ -f "$entry" ] && rm -f $entry
+ done
+)
+cat "$1" | (
+ cd "$2"
+ while read entry; do
+ [ -n "$entry" ] || break
+ [ -d "$entry" ] && rmdir "$entry" > /dev/null 2>&1
+ done
+)
+true